grammar Transaction;

options {
	language = Java;
}

@header {
  package com.moneydance.apps.md.grammar;
}

@lexer::header {
  package com.moneydance.apps.md.grammar;
}

transaction
	:	(DESCRIPTION AMOUNT) | (AMOUNT DESCRIPTION);

WORD : ('a'..'z' | 'A'..'Z' | '&' | ';' | '*' | '-' | '_' | '+' | '@' | '.' | ',' | ':')+;
DESCRIPTION : (WORD WS?)+;
DIGIT    :  '0'..'9';
CURRENCY : '$' | '£' | '€' | 'USD' | 'EUR' | 'GBP';
NUMBER : DIGIT+ | (DIGIT* ('.'|',') DIGIT+) ;
AMOUNT : WS? NUMBER WS?;
WS : ( '\t' | ' ' | '\r' | '\n'| '\u000C' )+ {$channel = HIDDEN;};
